#include "svnmodel.h"
#include <QApplication>
#include <QGraphicsView>
#include <QGraphicsScene>
#include <QVBoxLayout>
#include <QComboBox>
#include <QTextBrowser>

int
main(int argc, char** argv) {
    QApplication app(argc, argv);

    QWidget* window = new QWidget();

    QComboBox* urlinput = new QComboBox();
    QGraphicsScene* scene = new QGraphicsScene();
    QTextBrowser* browser = new QTextBrowser();
    SvnModel* model = new SvnModel(scene);
    QGraphicsView* view = new QGraphicsView(scene);
    view->setFrameShape(QFrame::NoFrame);

    urlinput->setEditable(true);
    urlinput->addItem("trunk/KDE/kdelibs");
    urlinput->addItem("trunk/playground/base/strigi");

    view->viewport()->installEventFilter(model);
    view->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    scene->setSceneRect(QRectF(0,0,1000,20));
    view->setAlignment(Qt::AlignLeft | Qt::AlignTop);
    view->setMinimumHeight(51);
    view->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);

    browser->setOpenExternalLinks(true);
    browser->setHtml("<html><h1>SvnLine</h1><p>This small application demonstrates a simple idea for a timeline widget. You can type in a KDE svn directory and the last 250 commit messages will be retrieved. Then you can zoom in and out of the svn line by rolling the mouse wheel over it.</p>");

    QObject::connect(urlinput, SIGNAL(activated(const QString&)),
        model, SLOT(show(const QString&)));
    QObject::connect(model, SIGNAL(itemActivated(const QString&)),
        browser, SLOT(setHtml(const QString &)));

    QVBoxLayout *layout = new QVBoxLayout();
    layout->addWidget(browser);
    layout->addWidget(view);
    layout->addWidget(urlinput);
    window->setLayout(layout);
    window->show();
    return app.exec();
}
